import * as i0 from '@angular/core';
import { Injectable, EventEmitter, Component, Input, Output, NgModule } from '@angular/core';
import * as i1 from '@angular/common';
import { WeekDay, CommonModule } from '@angular/common';

class NgxWeekdayPickerService {
    constructor() { }
}
NgxWeekdayPickerService.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.4", ngImport: i0, type: NgxWeekdayPickerService, deps: [], target: i0.ɵɵFactoryTarget.Injectable });
NgxWeekdayPickerService.ɵprov = i0.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "14.0.4", ngImport: i0, type: NgxWeekdayPickerService, providedIn: 'root' });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.4", ngImport: i0, type: NgxWeekdayPickerService, decorators: [{
            type: Injectable,
            args: [{
                    providedIn: 'root'
                }]
        }], ctorParameters: function () { return []; } });

class NgxWeekdayPickerComponent {
    constructor() {
        this.weekStart = WeekDay.Monday;
        this.daysNames = [
            'MO',
            'TU',
            'WE',
            'TH',
            'FR',
            'SA',
            'SU',
        ];
        this.disabledList = [];
        this.selected = [];
        this.dayWidth = '40px';
        this.fontSize = '14px';
        this.borderRadius = '6px';
        this.borderWidth = '1px';
        this.activeColor = '#fff';
        this.activeBgColor = '#2196f3';
        this.activeBorderColor = '#008eff';
        this.inactiveColor = '#000';
        this.inactiveBgColor = '#fff';
        this.inactiveBorderColor = '#ddd';
        this.isMulti = true;
        this.selectedChanged = new EventEmitter();
        this.days = [
            { day: WeekDay.Monday, name: 'Monday', isSelected: false, isDisabled: false, },
            { day: WeekDay.Tuesday, name: 'Tuesday', isSelected: false, isDisabled: false, },
            { day: WeekDay.Wednesday, name: 'Wednesday', isSelected: false, isDisabled: false, },
            { day: WeekDay.Thursday, name: 'Thursday', isSelected: false, isDisabled: false, },
            { day: WeekDay.Friday, name: 'Friday', isSelected: false, isDisabled: false, },
            { day: WeekDay.Saturday, name: 'Saturday', isSelected: false, isDisabled: false, },
            { day: WeekDay.Sunday, name: 'Sunday', isSelected: false, isDisabled: false, },
        ];
        this.value = null;
    }
    ngOnInit() {
        this.init();
    }
    init() {
        // init daysNames
        this.days.forEach((d, i) => {
            d.name = this.daysNames[i];
        });
        // init weekStart
        const index = this.days.map(x => x.day).indexOf(this.weekStart);
        for (let i = 0; i < index; i++) {
            this.days.push(this.days.shift());
            this.daysNames.push(this.daysNames.shift());
        }
        // init disabled
        this.days.filter(x => this.disabledList.includes(x.day)).forEach(x => x.isDisabled = true);
        // init selected
        if (Array.isArray(this.selected)) {
            this.days.filter(x => this.selected.includes(x.day)).forEach(x => x.isSelected = true);
        }
        else {
            this.days.filter(x => this.selected === x.day).forEach(x => x.isSelected = true);
        }
    }
    dayClicked(d) {
        if (d.isDisabled) {
            return;
        }
        if (!d.isSelected && !this.isMulti) {
            this.days.forEach(x => x.isSelected = false);
        }
        d.isSelected = !d.isSelected;
        if (this.isMulti) {
            this.value = this.days.filter(x => x.isSelected).map(x => x.day);
        }
        else {
            const t = this.days.find(x => x.isSelected);
            this.value = t ? t.day : null;
        }
        console.log(this.value);
        this.selectedChanged.emit(this.value);
    }
}
NgxWeekdayPickerComponent.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.4", ngImport: i0, type: NgxWeekdayPickerComponent, deps: [], target: i0.ɵɵFactoryTarget.Component });
NgxWeekdayPickerComponent.ɵcmp = i0.ɵɵngDeclareComponent({ minVersion: "14.0.0", version: "14.0.4", type: NgxWeekdayPickerComponent, selector: "ngx-weekday-picker", inputs: { weekStart: "weekStart", daysNames: "daysNames", disabledList: "disabledList", selected: "selected", dayWidth: "dayWidth", fontSize: "fontSize", borderRadius: "borderRadius", borderWidth: "borderWidth", activeColor: "activeColor", activeBgColor: "activeBgColor", activeBorderColor: "activeBorderColor", inactiveColor: "inactiveColor", inactiveBgColor: "inactiveBgColor", inactiveBorderColor: "inactiveBorderColor", isMulti: "isMulti" }, outputs: { selectedChanged: "selectedChanged" }, ngImport: i0, template: "<div class=\"days-container\"\n     [ngStyle]=\"{\n      '--fontSize':fontSize,\n      '--dayWidth':dayWidth,\n      '--borderRadius':borderRadius,\n      '--borderWidth':borderWidth,\n\n      '--activeBorderColor':activeBorderColor,\n      '--inactiveBorderColor':inactiveBorderColor,\n      \n\n      '--activeColor':activeColor,\n      '--activeBgColor':activeBgColor,\n      '--inactiveColor':inactiveColor,\n      '--inactiveBgColor':inactiveBgColor\n    }\">\n  <button *ngFor=\"let d of days\"\n          (click)=\"dayClicked(d)\"\n          [ngClass]=\" {'active':d.isSelected,'disabled':d.isDisabled}\">{{d.name}}</button>\n</div>", styles: [".days-container{display:inline-flex;font-size:var(--fontSize)}.days-container :last-child{border-right:solid;border-right-color:var(--inactiveBorderColor);border-width:var(--borderWidth);border-radius:0 var(--borderRadius) var(--borderRadius) 0}.days-container :first-child{border-width:var(--borderWidth);border-radius:var(--borderRadius) 0 0 var(--borderRadius)}button:hover{transform:scale(1.05)}button{display:flex;align-items:center;justify-content:center;padding:3px;width:var(--dayWidth);height:var(--dayWidth);border:solid;border-color:var(--inactiveBorderColor);border-width:var(--borderWidth);border-right:none;color:var(--inactiveColor);background-color:var(--inactiveBgColor);transition:all .3s ease-in-out}button.active{color:var(--activeColor);background-color:var(--activeBgColor);border-color:var(--activeBorderColor);border-right-color:var(--activeBorderColor)!important}\n"], dependencies: [{ kind: "directive", type: i1.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { kind: "directive", type: i1.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { kind: "directive", type: i1.NgStyle, selector: "[ngStyle]", inputs: ["ngStyle"] }] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.4", ngImport: i0, type: NgxWeekdayPickerComponent, decorators: [{
            type: Component,
            args: [{ selector: 'ngx-weekday-picker', template: "<div class=\"days-container\"\n     [ngStyle]=\"{\n      '--fontSize':fontSize,\n      '--dayWidth':dayWidth,\n      '--borderRadius':borderRadius,\n      '--borderWidth':borderWidth,\n\n      '--activeBorderColor':activeBorderColor,\n      '--inactiveBorderColor':inactiveBorderColor,\n      \n\n      '--activeColor':activeColor,\n      '--activeBgColor':activeBgColor,\n      '--inactiveColor':inactiveColor,\n      '--inactiveBgColor':inactiveBgColor\n    }\">\n  <button *ngFor=\"let d of days\"\n          (click)=\"dayClicked(d)\"\n          [ngClass]=\" {'active':d.isSelected,'disabled':d.isDisabled}\">{{d.name}}</button>\n</div>", styles: [".days-container{display:inline-flex;font-size:var(--fontSize)}.days-container :last-child{border-right:solid;border-right-color:var(--inactiveBorderColor);border-width:var(--borderWidth);border-radius:0 var(--borderRadius) var(--borderRadius) 0}.days-container :first-child{border-width:var(--borderWidth);border-radius:var(--borderRadius) 0 0 var(--borderRadius)}button:hover{transform:scale(1.05)}button{display:flex;align-items:center;justify-content:center;padding:3px;width:var(--dayWidth);height:var(--dayWidth);border:solid;border-color:var(--inactiveBorderColor);border-width:var(--borderWidth);border-right:none;color:var(--inactiveColor);background-color:var(--inactiveBgColor);transition:all .3s ease-in-out}button.active{color:var(--activeColor);background-color:var(--activeBgColor);border-color:var(--activeBorderColor);border-right-color:var(--activeBorderColor)!important}\n"] }]
        }], ctorParameters: function () { return []; }, propDecorators: { weekStart: [{
                type: Input
            }], daysNames: [{
                type: Input
            }], disabledList: [{
                type: Input
            }], selected: [{
                type: Input
            }], dayWidth: [{
                type: Input
            }], fontSize: [{
                type: Input
            }], borderRadius: [{
                type: Input
            }], borderWidth: [{
                type: Input
            }], activeColor: [{
                type: Input
            }], activeBgColor: [{
                type: Input
            }], activeBorderColor: [{
                type: Input
            }], inactiveColor: [{
                type: Input
            }], inactiveBgColor: [{
                type: Input
            }], inactiveBorderColor: [{
                type: Input
            }], isMulti: [{
                type: Input
            }], selectedChanged: [{
                type: Output
            }] } });

class NgxWeekdayPickerModule {
}
NgxWeekdayPickerModule.ɵfac = i0.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "14.0.4", ngImport: i0, type: NgxWeekdayPickerModule, deps: [], target: i0.ɵɵFactoryTarget.NgModule });
NgxWeekdayPickerModule.ɵmod = i0.ɵɵngDeclareNgModule({ minVersion: "14.0.0", version: "14.0.4", ngImport: i0, type: NgxWeekdayPickerModule, declarations: [NgxWeekdayPickerComponent], imports: [CommonModule], exports: [NgxWeekdayPickerComponent] });
NgxWeekdayPickerModule.ɵinj = i0.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "14.0.4", ngImport: i0, type: NgxWeekdayPickerModule, imports: [CommonModule] });
i0.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "14.0.4", ngImport: i0, type: NgxWeekdayPickerModule, decorators: [{
            type: NgModule,
            args: [{
                    declarations: [
                        NgxWeekdayPickerComponent
                    ],
                    imports: [
                        CommonModule
                    ],
                    exports: [
                        NgxWeekdayPickerComponent
                    ]
                }]
        }] });

/*
 * Public API Surface of ngx-weekday-picker
 */

/**
 * Generated bundle index. Do not edit.
 */

export { NgxWeekdayPickerComponent, NgxWeekdayPickerModule, NgxWeekdayPickerService };
//# sourceMappingURL=ngx-weekday-picker.mjs.map
